Package com.google.protobuf

## Interface MessageLite.Builder

All Superinterfaces:
  `java.lang.Cloneable`, `MessageLiteOrBuilder`

All Known Subinterfaces:
  `Message.Builder`

All Known Implementing Classes:
  `AbstractMessage.Builder`, `AbstractMessageLite.Builder`, `DescriptorProtos.DescriptorProto.Builder`, `DescriptorProtos.DescriptorProto.ExtensionRange.Builder`, `DescriptorProtos.EnumDescriptorProto.Builder`, `DescriptorProtos.EnumOptions.Builder`, `DescriptorProtos.EnumValueDescriptorProto.Builder`, `DescriptorProtos.EnumValueOptions.Builder`, `DescriptorProtos.FieldDescriptorProto.Builder`, `DescriptorProtos.FieldOptions.Builder`, `DescriptorProtos.FileDescriptorProto.Builder`, `DescriptorProtos.FileDescriptorSet.Builder`, `DescriptorProtos.FileOptions.Builder`, `DescriptorProtos.MessageOptions.Builder`, `DescriptorProtos.MethodDescriptorProto.Builder`, `DescriptorProtos.MethodOptions.Builder`, `DescriptorProtos.OneofDescriptorProto.Builder`, `DescriptorProtos.ServiceDescriptorProto.Builder`, `DescriptorProtos.ServiceOptions.Builder`, `DescriptorProtos.SourceCodeInfo.Builder`, `DescriptorProtos.SourceCodeInfo.Location.Builder`, `DescriptorProtos.UninterpretedOption.Builder`, `DescriptorProtos.UninterpretedOption.NamePart.Builder`, `DynamicMessage.Builder`, `GeneratedMessage.Builder`, `GeneratedMessage.ExtendableBuilder`, `GeneratedMessageLite.Builder`, `GeneratedMessageLite.ExtendableBuilder`, `UnknownFieldSet.Builder`

Enclosing interface:
  MessageLite

    public static interface MessageLite.Builder
    extends MessageLiteOrBuilder, java.lang.Cloneable

Abstract interface implemented by Protocol Message builders.

### Method Summary

All Methods Instance Methods Abstract Methods
`MessageLite` `build()` Constructs the message based on the state of the Builder.
`MessageLite` `buildPartial()` Like `build()`, but does not throw an exception if the message is missing required fields.
`MessageLite.Builder` `clear()` Resets all fields to their default values.
`MessageLite.Builder` `clone()` Clones the Builder.
`boolean` `mergeDelimitedFrom​(java.io.InputStream input)` Like `mergeFrom(InputStream)`, but does not read until EOF.
`boolean` `mergeDelimitedFrom​(java.io.InputStream input, ExtensionRegistryLite extensionRegistry)` Like `mergeDelimitedFrom(InputStream)` but supporting extensions.
`MessageLite.Builder` `mergeFrom​(byte[] data)` Parse `data` as a message of this type and merge it with the message being built.
`MessageLite.Builder` `mergeFrom​(byte[] data, int off, int len)` Parse `data` as a message of this type and merge it with the message being built.
`MessageLite.Builder` `mergeFrom​(byte[] data, int off, int len, ExtensionRegistryLite extensionRegistry)` Parse `data` as a message of this type and merge it with the message being built.
`MessageLite.Builder` `mergeFrom​(byte[] data, ExtensionRegistryLite extensionRegistry)` Parse `data` as a message of this type and merge it with the message being built.
`MessageLite.Builder` `mergeFrom​(ByteString data)` Parse `data` as a message of this type and merge it with the message being built.
`MessageLite.Builder` `mergeFrom​(ByteString data, ExtensionRegistryLite extensionRegistry)` Parse `data` as a message of this type and merge it with the message being built.
`MessageLite.Builder` `mergeFrom​(CodedInputStream input)` Parses a message of this type from the input and merges it with this message.
`MessageLite.Builder` `mergeFrom​(CodedInputStream input, ExtensionRegistryLite extensionRegistry)` Like `mergeFrom(CodedInputStream)`, but also parses extensions.
`MessageLite.Builder` `mergeFrom​(java.io.InputStream input)` Parse a message of this type from `input` and merge it with the message being built.
`MessageLite.Builder` `mergeFrom​(java.io.InputStream input, ExtensionRegistryLite extensionRegistry)` Parse a message of this type from `input` and merge it with the message being built.

### Methods inherited from interface com.google.protobuf.MessageLiteOrBuilder

`getDefaultInstanceForType, isInitialized`

### Method Detail

#### clear

    MessageLite.Builder clear()

Resets all fields to their default values.

#### build

    MessageLite build()

Constructs the message based on the state of the Builder. Subsequent changes to the Builder will not affect the returned message.

Throws:
  `UninitializedMessageException` - The message is missing one or more required fields (i.e. `MessageLiteOrBuilder.isInitialized()` returns false). Use `buildPartial()` to bypass this check.

#### buildPartial

    MessageLite buildPartial()

Like `build()`, but does not throw an exception if the message is missing required fields. Instead, a partial message is returned. Subsequent changes to the Builder will not affect the returned message.

#### clone

    MessageLite.Builder clone()

Clones the Builder.

See Also:
  `Object.clone()`

#### mergeFrom

    MessageLite.Builder mergeFrom​(CodedInputStream input)
                           throws java.io.IOException

Parses a message of this type from the input and merges it with this message.

Warning: This does not verify that all required fields are present in the input message. If you call `build()` without setting all required fields, it will throw an `UninitializedMessageException`, which is a `RuntimeException` and thus might not be caught. There are a few good ways to deal with this:

- Call `MessageLiteOrBuilder.isInitialized()` to verify that all required fields are set before building.
- Use `buildPartial()` to build, which ignores missing required fields.

Note: The caller should call `CodedInputStream.checkLastTagWas(int)` after calling this to verify that the last tag seen was the appropriate end-group tag, or zero for EOF.

Throws:
  `java.io.IOException`

#### mergeFrom

    MessageLite.Builder mergeFrom​(CodedInputStream input,
                                  ExtensionRegistryLite extensionRegistry)
                           throws java.io.IOException

Like `mergeFrom(CodedInputStream)`, but also parses extensions. The extensions that you want to be able to parse must be registered in `extensionRegistry`. Extensions not in the registry will be treated as unknown fields.

Throws:
  `java.io.IOException`

#### mergeFrom

    MessageLite.Builder mergeFrom​(ByteString data)
                           throws InvalidProtocolBufferException

Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `mergeFrom(CodedInputStream)`.

Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    MessageLite.Builder mergeFrom​(ByteString data,
                                  ExtensionRegistryLite extensionRegistry)
                           throws InvalidProtocolBufferException

Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    MessageLite.Builder mergeFrom​(byte[] data)
                           throws InvalidProtocolBufferException

Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `mergeFrom(CodedInputStream)`.

Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    MessageLite.Builder mergeFrom​(byte[] data,
                                  int off,
                                  int len)
                           throws InvalidProtocolBufferException

Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `mergeFrom(CodedInputStream)`.

Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    MessageLite.Builder mergeFrom​(byte[] data,
                                  ExtensionRegistryLite extensionRegistry)
                           throws InvalidProtocolBufferException

Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    MessageLite.Builder mergeFrom​(byte[] data,
                                  int off,
                                  int len,
                                  ExtensionRegistryLite extensionRegistry)
                           throws InvalidProtocolBufferException

Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Returns:
  this
Throws:
  `InvalidProtocolBufferException`

#### mergeFrom

    MessageLite.Builder mergeFrom​(java.io.InputStream input)
                           throws java.io.IOException

Parse a message of this type from `input` and merge it with the message being built. This is just a small wrapper around `mergeFrom(CodedInputStream)`. Note that this method always reads the entire input (unless it throws an exception). If you want it to stop earlier, you will need to wrap your input in some wrapper stream that limits reading. Or, use `MessageLite.writeDelimitedTo(OutputStream)` to write your message and `mergeDelimitedFrom(InputStream)` to read it.

Despite usually reading the entire input, this does not close the stream.

Returns:
  this
Throws:
  `java.io.IOException`

#### mergeFrom

    MessageLite.Builder mergeFrom​(java.io.InputStream input,
                                  ExtensionRegistryLite extensionRegistry)
                           throws java.io.IOException

Parse a message of this type from `input` and merge it with the message being built. This is just a small wrapper around `mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Returns:
  this
Throws:
  `java.io.IOException`

#### mergeDelimitedFrom

    boolean mergeDelimitedFrom​(java.io.InputStream input)
                        throws java.io.IOException

Like `mergeFrom(InputStream)`, but does not read until EOF. Instead, the size of the message (encoded as a varint) is read first, then the message data. Use `MessageLite.writeDelimitedTo(OutputStream)` to write messages in this format.

Returns:
  True if successful, or false if the stream is at EOF when the method starts. Any other error (including reaching EOF during parsing) will cause an exception to be thrown.
Throws:
  `java.io.IOException`

#### mergeDelimitedFrom

    boolean mergeDelimitedFrom​(java.io.InputStream input,
                               ExtensionRegistryLite extensionRegistry)
                        throws java.io.IOException

Like `mergeDelimitedFrom(InputStream)` but supporting extensions.

Throws:
  `java.io.IOException`